
/*	Copyright (c) 1982 Dyadic Systems Limited	*/

/*	x f a c c

	external function access routines
*/

#include "apl.h"

/*	i n t   f r o m   a n y t h i n g	*/

int igetb(base,indx)
unsigned char *base;
unsigned indx;
{
	return ((base[indx>>3] << (indx&7)) & 0x80 ) != 0;
}

int igets(base,indx)
char *base;
unsigned indx;
{
	return base[indx];
}

int igeti(base,indx)
short *base;
unsigned indx;
{
	return base[indx];
}

int igetl(base,indx)
long *base;
unsigned indx;
{
	return base[indx];
}

int igetd(base,indx)	/* rounds double to nearest int */
double *base;
unsigned indx;
{
	long round();
#ifdef DALIGN
	double align();

	return round(align((char*)base,indx));
#else
	return round(base[indx]);
#endif DALIGN
}
/*	l o n g   f r o m   a n y t h i n g	*/

long lgetb(base,indx)
unsigned char *base;
unsigned indx;
{
	return ((base[indx>>3] << (indx&7)) & 0x80 ) != 0;
}

long lgets(base,indx)
char *base;
unsigned indx;
{
	return base[indx];
}

long lgeti(base,indx)
short *base;
unsigned indx;
{
	return base[indx];
}

long lgetl(base,indx)
long *base;
unsigned indx;
{
	return base[indx];
}

long lgetd(base,indx)	/* rounds double to nearest long */
double *base;
unsigned indx;
{
	long round();
#ifdef DALIGN
	double align();

	return round(align((char*)base,indx));
#else
	return round(base[indx]);
#endif DALIGN
}
/*	s e r v i c e s	*/

domer()
{
	error(DOMAIN);
}

nonce()
{
	error(NONCE);
}

static int  (*intfns[])()  = { domer,igetb,igets,igeti,igetl,igetd,nonce };
static long (*longfns[])() = { (long(*)()) domer,lgetb,lgets,lgeti,
				lgetl,lgetd, (long(*)()) nonce };

int (*initint(array))()
ARRAY *array;
{
	return intfns[array->eltype];
}

long (*initlong(array))()
ARRAY *array;
{
	return longfns[array->eltype];
}

static long	round(fval)
double fval;
{
	return fval + (fval<0 ? -.5:.5);
}

#ifdef DALIGN

static double align(base,indx) /* access off-boundary for double aligned m/cs */	
char *base;
unsigned indx;
{
	register char *iptr, *optr;
	register unsigned u;
	union {
		char c[sizeof(double)];
		double d;
	} val;

	iptr = base + sizeof(double)*indx;	/* point at source */
	optr = val.c;				/* point at destination */
	for (u=sizeof(double); u--;)		/* move a byte at a time */
		*optr++ = *iptr++;
	return val.d;				/* return the double value */
}

#endif DALIGN
/* d o u b l e   p u t  &  g e t	*/

typedef	struct
	{char	cfloat[sizeof(double)];
	} Doubarray;
typedef struct
	{union
		{Doubarray	sfloat;
		double		dfloat;
		} ufloat;
	} Doubunion;

putd(val, base, indx)
double		val, *base;
unsigned	indx;
{
#ifdef DALIGN
	Doubunion	dunion;

	dunion.ufloat.dfloat = val;
	*((Doubarray*)(base+indx)) = dunion.ufloat.sfloat;
#else
	base[indx] = val;
#endif DALIGN
}

double		getd(base, indx)
double		*base;
unsigned	indx;
{
#ifdef DALIGN
	Doubunion	 dunion;

	dunion.ufloat.sfloat = *((Doubarray*)(base+indx));
	return dunion.ufloat.dfloat;
#else
	return base[indx];
#endif DALIGN
}

/*	Copyright (c) 1982 Dyadic Systems Limited	*/


