
/*	Copyright (c) 1982 Dyadic Systems Limited	*/

#define	DS90

/*			MACHINE DEPENDENCIES				*/

#ifdef	DS90		/* dataindustrier				*/
#endif	DS90

#ifdef	FORTUNE		/* fortune systems				*/
#define	ONLYSBRK
#define	NEWDRIVER
#endif

#ifdef	GOULD67		/* gould 3267					*/
#define DALIGN
#endif

#ifdef	PERKIN		/* perkin-elmer					*/
#define DALIGN
#endif

#ifdef	ZEUS_2_2	/* zilog s8000 zeus 2.2				*/
#define	ZILOG
#endif

#ifdef	ZEUS_3_2	/* zilog s8000 zeus 3.2				*/
#define	BELL
#define	TIMEOV	3
#define	ZILOG
#endif

/*			end of MACHINE DEPENDENCIES			*/

/*	zilogs use setret not setjmp					*/

#ifdef	ZILOG
#include <setret.h>
#define	setjmp	setret		/* included only for zilog 'zeus'	*/
#define	jmp_buf	ret_buf		/* version of unix, which uses ret	*/
#define	longjmp	longret		/* instead of jmp			*/
#else
#include <setjmp.h>
#endif

#include <signal.h>

#define ARGSPIPE 3		/* pipe allocations			*/
#define RSLTPIPE 4

				/* function syntax			*/
#define	RSLT	0040		/* returns a result			*/
#define	SHYR	0140		/* returns a shy result			*/
#define	MONA	0004		/* takes only a right argument		*/
#define	DYAD	0014		/* takes a left and right argument	*/
#define	OPTL	0034		/* left argument is optional (divalent)	*/
#define	INTR	0200		/* handles its own interrupts		*/

#define ALIGNWD(A) unsigned:sizeof(unsigned)*8-A

typedef struct			/* an APL ARRAY				*/
{
	unsigned length;	/* total length in words including self	*/
	unsigned type	:4;	/* see below				*/
	unsigned rank	:4;	/* rank of array			*/
	unsigned eltype	:4;	/* type of all the elements (see below)	*/
	ALIGNWD(12);		/* word align for 68000			*/
	unsigned shape[1];	/* rho vector - really shape[rank]	*/
} ARRAY;

#define SIMPLE 0xf		/* APL ARRAY types			*/
#define NESTED 0x7

#define	CHAR	0		/* APL ARRAY eltypes			*/
#define	BOOL	1
#define	SINT	2
#define	INTG	3
#define	LONG	4
#define	DOUB	5
#define	PNTR	6

				/* machine constants & types		*/
#define	BITS_PER_BYTE	8
				/* this shouldn't change		*/
#define	DINT	((sizeof(int)==2) ? INTG:LONG)
				/* a four byte integer			*/
#define	WDBITS	((sizeof(int)==2) ? 4:5)
				/* left shift to conv words to bits	*/
				/* 4 if sizeof(int)==2			*/
				/* 5 if sizeof(int)==4			*/


#define	WSFULL		1	/* APL error codes			*/
#define	SYNTAX		2
#define	INDEX		3
#define	RANK		4
#define	LENGTH		5
#define	VALUE		6
#define	FORMAT		7
#define	LIMIT		10
#define	DOMAIN		11
#define	HOLD		12
#define	LSTFULL		15
#define	NONCE		16
#define	NOPIPES		30
#define	NOPROCS		76

#define	STOP		1001
#define	ATTN		1002
#define	INTERRUPT	1003
#define	INPUT_INTERRUPT	1004
#define	EOF_INTERRUPT	1005
#define	TIMEOUT		1006

/*	Copyright (c) 1982 Dyadic Systems Limited	*/


